(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("React"));
	else if(typeof define === 'function' && define.amd)
		define(["React"], factory);
	else if(typeof exports === 'object')
		exports["ReactImageMulti"] = factory(require("React"));
	else
		root["ReactImageMulti"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var _React$PropTypes = _react2.default.PropTypes,
	    node = _React$PropTypes.node,
	    oneOfType = _React$PropTypes.oneOfType,
	    string = _React$PropTypes.string,
	    array = _React$PropTypes.array;

	var cache = {};

	var Img = function (_Component) {
	  _inherits(Img, _Component);

	  function Img(props) {
	    _classCallCheck(this, Img);

	    var _this = _possibleConstructorReturn(this, (Img.__proto__ || Object.getPrototypeOf(Img)).call(this, props));

	    _this.onLoad = function () {
	      cache[_this.sourceList[_this.state.currentIndex]] = true;
	      if (_this.i) _this.setState({ isLoaded: true });
	    };

	    _this.srcToArray = function (src) {
	      return (Array.isArray(src) ? src : [src]).filter(function (x) {
	        return x;
	      });
	    };

	    _this.onError = function () {
	      cache[_this.sourceList[_this.state.currentIndex]] = false;
	      // if the current image has already been destroyed, we are probably no longer mounted
	      // no need to do anything then
	      if (!_this.i) return;

	      // currentIndex is zero bases, length is 1 based.
	      // if we have no more sources to try, return - we are done
	      if (_this.state.currentIndex + 1 === _this.sourceList.length) return _this.setState({ isLoading: false });

	      // before loading the next image, check to see if it was loaded ever in the past
	      for (var i = 0; i < _this.sourceList.length - _this.state.currentIndex + 1; i++) {
	        // get next img
	        var src = _this.sourceList[_this.state.currentIndex + i];

	        // if we have never seen it, its the one we want to try next
	        if (!(src in cache)) {
	          _this.setState({ currentIndex: _this.state.currentIndex + i });
	          break;
	        }

	        // if we know it exists, use it!
	        if (cache[src] === true) {
	          _this.setState({ currentIndex: _this.state.currentIndex + i, isLoading: false, isLoaded: true });
	          return true;
	        }

	        // if we know it doesn't exist, skip it!
	        if (cache[src] === false) continue;
	      }

	      // otherwise, try the next img
	      _this.loadImg();
	    };

	    _this.loadImg = function () {
	      _this.i = new Image();
	      _this.i.src = _this.sourceList[_this.state.currentIndex];
	      _this.i.onload = _this.onLoad;
	      _this.i.onerror = _this.onError;
	    };

	    _this.unloadImg = function () {
	      delete _this.i.onerror;
	      delete _this.i.onload;
	      delete _this.i.src;
	      delete _this.i;
	    };

	    _this.sourceList = _this.srcToArray(_this.props.src);

	    // check cache to decide at which index to start
	    for (var i = 0; i < _this.sourceList.length; i++) {
	      // if we've never seen this image before, the cache wont help. GET OUT!
	      if (!(_this.sourceList[i] in cache)) break;

	      // if we have loaded this image before, just load it again
	      if (cache[_this.sourceList[i]] === true) {
	        var _ret;

	        _this.state = { currentIndex: i, isLoading: false, isLoaded: true };
	        return _ret = true, _possibleConstructorReturn(_this, _ret);
	      }
	    }

	    _this.state = _this.sourceList.length
	    // 'normal' opperation: start at 0 and try to load
	    ? { currentIndex: 0, isLoading: true, isLoaded: false }
	    // if we dont have any sources, jump directly to unloaded
	    : { isLoading: false, isLoaded: false };
	    return _this;
	  }

	  _createClass(Img, [{
	    key: 'componentDidMount',
	    value: function componentDidMount() {
	      // kick off process
	      if (this.state.isLoading) this.loadImg();
	    }
	  }, {
	    key: 'componentWillUnmount',
	    value: function componentWillUnmount() {
	      // ensure that we dont leave any lingering listeners
	      if (this.i) this.unloadImg();
	    }
	  }, {
	    key: 'componentWillReceiveProps',
	    value: function componentWillReceiveProps(nextProps) {
	      var _this2 = this;

	      var src = this.srcToArray(nextProps.src);

	      var srcAdded = src.filter(function (s) {
	        return _this2.sourceList.indexOf(s) === -1;
	      });
	      var srcRemoved = this.sourceList.filter(function (s) {
	        return src.indexOf(s) === -1;
	      });

	      // if src prop changed, restart the loading process
	      if (srcAdded.length || srcRemoved.length) {
	        this.sourceList = src;

	        // if we dont have any sources, jump directly to unloader
	        if (!src.length) return this.setState({ isLoading: false, isLoaded: false });
	        this.setState({ currentIndex: 0, isLoading: true, isLoaded: false }, this.loadImg);
	      }
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      // if we have loaded, show img
	      if (this.state.isLoaded) {
	        // clear non img props
	        var _props = this.props,
	            src = _props.src,
	            loader = _props.loader,
	            unloader = _props.unloader,
	            rest = _objectWithoutProperties(_props, ['src', 'loader', 'unloader']); //eslint-disable-line


	        return _react2.default.createElement('img', _extends({ src: this.sourceList[this.state.currentIndex] }, rest));
	      }

	      // if we are still trying to load, show img and a loader if requested
	      if (!this.state.isLoaded && this.state.isLoading) return this.props.loader ? this.props.loader : null;

	      // if we have given up on loading, show a place holder if requested, or nothing
	      if (!this.state.isLoaded && !this.state.isLoading) return this.props.unloader ? this.props.unloader : null;
	    }
	  }]);

	  return Img;
	}(_react.Component);

	Img.propTypes = {
	  loader: node,
	  unloader: node,
	  src: oneOfType([string, array])
	};
	Img.defaultProps = {
	  loader: false,
	  unloader: false,
	  src: []
	};
	exports.default = Img;

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ }
/******/ ])
});
;